Package ghidra.program.model.mem

# Class StubMemory

java.lang.Object
ghidra.program.model.address.AddressSet
ghidra.program.model.mem.StubMemory

All Implemented Interfaces:
  `AddressSetView`, `Memory`, `Iterable<AddressRange>`

public class StubMemory extends AddressSet implements Memory
MemoryStub can be extended for use by tests. It throws an UnsupportedOperationException for all methods in the Memory interface. Any method that is needed for your test can then be overridden so it can provide its own test implementation and return value.

- ## Field Summary

  ### Fields inherited from interface ghidra.program.model.mem.Memory

  `GBYTE, GBYTE_SHIFT_FACTOR, MAX_BINARY_SIZE, MAX_BINARY_SIZE_GB, MAX_BLOCK_SIZE, MAX_BLOCK_SIZE_GB`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StubMemory()`
  `StubMemory(byte[] bytes)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MemoryBlock`
  `convertToInitialized(MemoryBlock uninitializedBlock, byte initialValue)`
  Convert an existing uninitialized block with an initialized block.
  `MemoryBlock`
  `convertToUninitialized(MemoryBlock initializedBlock)`
  `MemoryBlock`
  `createBitMappedBlock(String name, Address start, Address mappedAddress, long length, boolean overlay)`
  Create a bit-mapped overlay memory block and add it to this Memory.
  `MemoryBlock`
  `createBlock(MemoryBlock block, String name, Address start, long length)`
  Creates a MemoryBlock at the given address with the same properties as block, and adds it to this Memory.
  `MemoryBlock`
  `createByteMappedBlock(String name, Address start, Address mappedAddress, long length, ByteMappingScheme byteMappingScheme, boolean overlay)`
  Create a byte-mapped memory block and add it to this memory.
  `FileBytes`
  `createFileBytes(String filename, long offset, long size, InputStream is, TaskMonitor monitor)`
  Stores a sequence of bytes into the program.
  `MemoryBlock`
  `createInitializedBlock(String name, Address start, long size, byte initialValue, TaskMonitor monitor, boolean overlay)`
  Create an initialized memory block initialized and add it to this Memory.
  `MemoryBlock`
  `createInitializedBlock(String name, Address start, FileBytes fileBytes, long offset, long size, boolean overlay)`
  Create an initialized memory block using bytes from a `FileBytes` object.
  `MemoryBlock`
  `createInitializedBlock(String name, Address start, InputStream is, long length, TaskMonitor monitor, boolean overlay)`
  Create an initialized memory block based upon a data `InputStream` and add it to this Memory.
  `MemoryBlock`
  `createUninitializedBlock(String name, Address start, long size, boolean overlay)`
  Create an uninitialized memory block and add it to this Memory.
  `boolean`
  `deleteFileBytes(FileBytes descriptor)`
  Deletes a stored sequence of file bytes.
  `Address`
  `findBytes(Address addr, byte[] bytes, byte[] masks, boolean forward, TaskMonitor monitor)`
  Finds a sequence of contiguous bytes that match the given byte array at all bit positions where the mask contains an "on" bit.
  `Address`
  `findBytes(Address startAddr, Address endAddr, byte[] bytes, byte[] masks, boolean forward, TaskMonitor monitor)`
  Finds a sequence of contiguous bytes that match the given byte array at all bit positions where the mask contains an "on" bit.
  `Address`
  `findFirstAddressInCommon(AddressSetView set)`
  Finds the first address in this collection that is also in the given addressSet.
  `AddressIterator`
  `getAddresses(boolean forward)`
  Returns an iterator over all addresses in this set.
  `AddressIterator`
  `getAddresses(Address start, boolean forward)`
  Returns an iterator over the addresses in this address set starting at the start address
  `AddressRangeIterator`
  `getAddressRanges()`
  `AddressRangeIterator`
  `getAddressRanges(boolean forward)`
  Returns an iterator over the ranges in the specified order
  `AddressRangeIterator`
  `getAddressRanges(Address start, boolean forward)`
  Returns an iterator of address ranges starting with the range that contains the given address.
  `AddressSourceInfo`
  `getAddressSourceInfo(Address address)`
  Returns information (`AddressSourceInfo`) about the byte source at the given address.
  `List<FileBytes>`
  `getAllFileBytes()`
  Returns a list of all the stored original file bytes objects
  `AddressSetView`
  `getAllInitializedAddressSet()`
  Returns the set of addresses which correspond to all memory blocks that have initialized data.
  `MemoryBlock`
  `getBlock(Address addr)`
  Returns the Block which contains addr.
  `MemoryBlock`
  `getBlock(String blockName)`
  Returns the Block with the specified blockName
  `MemoryBlock[]`
  `getBlocks()`
  Returns an array containing all the memory blocks.
  `byte`
  `getByte(Address addr)`
  Get byte at addr.
  `int`
  `getBytes(Address addr, byte[] dest)`
  Get dest.length number of bytes starting at the given address.
  `int`
  `getBytes(Address addr, byte[] dest, int dIndex, int size)`
  Get size number of bytes starting at the given address and populates dest starting at dIndex.
  `AddressSetView`
  `getExecuteSet()`
  Returns the set of addresses which correspond to the executable memory.
  `AddressRange`
  `getFirstRange()`
  Returns the first range in this set or null if the set is empty;
  `AddressSetView`
  `getInitializedAddressSet()`
  Use `Memory.getLoadedAndInitializedAddressSet()` instead.
  `int`
  `getInt(Address addr)`
  Get the int at addr.
  `int`
  `getInt(Address addr, boolean bigEndian)`
  Get the int at addr using the specified endian order.
  `int`
  `getInts(Address addr, int[] dest)`
  Get dest.length number of ints starting at the given address.
  `int`
  `getInts(Address addr, int[] dest, int dIndex, int nElem)`
  Get dest.length number of ints starting at the given address.
  `int`
  `getInts(Address addr, int[] dest, int dIndex, int nElem, boolean isBigEndian)`
  Get dest.length number of ints starting at the given address.
  `AddressRange`
  `getLastRange()`
  Returns the last range in this set or null if the set is empty;
  `LiveMemoryHandler`
  `getLiveMemoryHandler()`
  Returns the live memory handler instance used by this memory.
  `AddressSetView`
  `getLoadedAndInitializedAddressSet()`
  Returns the set of addresses which correspond to all the "loaded" memory blocks that have initialized data.
  `long`
  `getLong(Address addr)`
  Get the long at addr.
  `long`
  `getLong(Address addr, boolean bigEndian)`
  Get the long at addr in the specified endian order.
  `int`
  `getLongs(Address addr, long[] dest)`
  Get dest.length number of longs starting at the given address.
  `int`
  `getLongs(Address addr, long[] dest, int dIndex, int nElem)`
  Get dest.length number of longs starting at the given address.
  `int`
  `getLongs(Address addr, long[] dest, int dIndex, int nElem, boolean isBigEndian)`
  Get dest.length number of longs starting at the given address.
  `Address`
  `getMaxAddress()`
  `Address`
  `getMinAddress()`
  `long`
  `getNumAddresses()`
  `int`
  `getNumAddressRanges()`
  `Program`
  `getProgram()`
  Returns the program that this memory belongs to.
  `AddressRange`
  `getRangeContaining(Address address)`
  Returns the range that contains the given address
  `short`
  `getShort(Address addr)`
  Get the short at addr.
  `short`
  `getShort(Address addr, boolean bigEndian)`
  Get the short at addr using the specified endian order.
  `int`
  `getShorts(Address addr, short[] dest)`
  Get dest.length number of shorts starting at the given address.
  `int`
  `getShorts(Address addr, short[] dest, int dIndex, int nElem)`
  Get dest.length number of shorts starting at the given address.
  `int`
  `getShorts(Address addr, short[] dest, int dIndex, int nElem, boolean isBigEndian)`
  Get dest.length number of shorts starting at the given address.
  `long`
  `getSize()`
  Get the memory size in bytes.
  `boolean`
  `intersects(Address start, Address end)`
  Determine if the start and end range intersects with the specified address set.
  `boolean`
  `intersects(AddressSetView addrSet)`
  Determine if this address set intersects with the specified address set.
  `boolean`
  `isBigEndian()`
  Returns true if the memory is bigEndian, false otherwise.
  `boolean`
  `isEmpty()`
  `Iterator<AddressRange>`
  `iterator()`
  Returns an iterator over the address ranges in this address set.
  `Iterator<AddressRange>`
  `iterator(boolean forward)`
  Returns an iterator over the ranges in the specified order
  `Iterator<AddressRange>`
  `iterator(Address start, boolean forward)`
  Returns an iterator of address ranges starting with the range that contains the given address.
  `MemoryBlock`
  `join(MemoryBlock blockOne, MemoryBlock blockTwo)`
  Join the two blocks to create a single memory block.
  `void`
  `moveBlock(MemoryBlock block, Address newStartAddr, TaskMonitor monitor)`
  Move the memory block containing source address to the destination address.
  `void`
  `removeBlock(MemoryBlock block, TaskMonitor monitor)`
  Remove the memory block.
  `void`
  `setByte(Address addr, byte value)`
  Write byte at addr.
  `void`
  `setBytes(Address addr, byte[] source)`
  Write size bytes from values at addr.
  `void`
  `setBytes(Address addr, byte[] source, int sIndex, int size)`
  Write an array of bytes.
  `void`
  `setInt(Address addr, int value)`
  Write int at addr.
  `void`
  `setInt(Address addr, int value, boolean bigEndian)`
  Write int at addr in the specified endian order.
  `void`
  `setLiveMemoryHandler(LiveMemoryHandler handler)`
  Sets the live memory handler
  `void`
  `setLong(Address addr, long value)`
  Write long at addr.
  `void`
  `setLong(Address addr, long value, boolean bigEndian)`
  Write long at addr in the specified endian order.
  `void`
  `setShort(Address addr, short value)`
  Write short at addr in big endian order.
  `void`
  `setShort(Address addr, short value, boolean bigEndian)`
  Write short at addr in the specified endian order.
  `void`
  `split(MemoryBlock block, Address addr)`
  Split a block at the given addr and create a new block starting at addr.
  `AddressSet`
  `xor(AddressSetView addrSet)`
  Computes the exclusive-or of this address set with the given set.

  ### Methods inherited from class ghidra.program.model.address.AddressSet

  `add, add, add, add, addRange, addRange, clear, contains, contains, contains, delete, delete, delete, deleteFromMin, deleteRange, deleteToMax, equals, hashCode, hasSameAddresses, intersect, intersectRange, printRanges, subtract, toList, toString, union`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface ghidra.program.model.address.AddressSetView

  `contains, contains, contains, hasSameAddresses, intersect, intersectRange, subtract, union`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

  ### Methods inherited from interface ghidra.program.model.mem.Memory

  `createByteMappedBlock, isExternalBlockAddress, locateAddressesForFileBytesOffset, locateAddressesForFileOffset`

- ## Constructor Details

  - ### StubMemory

    public StubMemory()

  - ### StubMemory

    public StubMemory(byte[] bytes)

- ## Method Details

  - ### isEmpty

    public boolean isEmpty()
    Specified by:
      `isEmpty` in interface `AddressSetView`
    Overrides:
      `isEmpty` in class `AddressSet`
    Returns:
      true if this set is empty.

  - ### getMinAddress

    public Address getMinAddress()
    Specified by:
      `getMinAddress` in interface `AddressSetView`
    Overrides:
      `getMinAddress` in class `AddressSet`
    Returns:
      the minimum address for this set. Returns null if the set is empty.

  - ### getMaxAddress

    public Address getMaxAddress()
    Specified by:
      `getMaxAddress` in interface `AddressSetView`
    Overrides:
      `getMaxAddress` in class `AddressSet`
    Returns:
      the maximum address for this set. Returns null if the set is empty.

  - ### getNumAddressRanges

    public int getNumAddressRanges()
    Specified by:
      `getNumAddressRanges` in interface `AddressSetView`
    Overrides:
      `getNumAddressRanges` in class `AddressSet`
    Returns:
      the number of address ranges in this set.

  - ### getAddressRanges

    public AddressRangeIterator getAddressRanges()
    Specified by:
      `getAddressRanges` in interface `AddressSetView`
    Overrides:
      `getAddressRanges` in class `AddressSet`
    Returns:
      an iterator over the address ranges in this address set.

  - ### getAddressRanges

    public AddressRangeIterator getAddressRanges(boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator over the ranges in the specified order
    Specified by:
      `getAddressRanges` in interface `AddressSetView`
    Overrides:
      `getAddressRanges` in class `AddressSet`
    Parameters:
      `forward` - the ranges are returned from lowest to highest, otherwise from highest to lowest
    Returns:
      an iterator over all the addresse ranges in the set.

  - ### getAddressRanges

    public AddressRangeIterator getAddressRanges(Address start, boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator of address ranges starting with the range that contains the given address. If there is no range containing the start address, then the the first range will be the next range greater than the start address if going forward, otherwise the range less than the start address
    Specified by:
      `getAddressRanges` in interface `AddressSetView`
    Overrides:
      `getAddressRanges` in class `AddressSet`
    Parameters:
      `start` - the address the the first range should contain.
      `forward` - true iterators forward, false backwards
    Returns:
      the AddressRange iterator

  - ### iterator

    public Iterator<AddressRange> iterator()
    Description copied from interface: `AddressSetView`
    Returns an iterator over the address ranges in this address set.
    Specified by:
      `iterator` in interface `AddressSetView`
    Specified by:
      `iterator` in interface `Iterable<AddressRange>`
    Overrides:
      `iterator` in class `AddressSet`

  - ### iterator

    public Iterator<AddressRange> iterator(boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator over the ranges in the specified order
    Specified by:
      `iterator` in interface `AddressSetView`
    Overrides:
      `iterator` in class `AddressSet`
    Parameters:
      `forward` - the ranges are returned from lowest to highest, otherwise from highest to lowest
    Returns:
      an iterator over all the addresse ranges in the set.

  - ### iterator

    public Iterator<AddressRange> iterator(Address start, boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator of address ranges starting with the range that contains the given address. If there is no range containing the start address, then the the first range will be the next range greater than the start address if going forward, otherwise the range less than the start address
    Specified by:
      `iterator` in interface `AddressSetView`
    Overrides:
      `iterator` in class `AddressSet`
    Parameters:
      `start` - the address the the first range should contain.
      `forward` - true iterators forward, false backwards
    Returns:
      the AddressRange iterator

  - ### getNumAddresses

    public long getNumAddresses()
    Specified by:
      `getNumAddresses` in interface `AddressSetView`
    Overrides:
      `getNumAddresses` in class `AddressSet`
    Returns:
      the number of addresses in this set.

  - ### getAddresses

    public AddressIterator getAddresses(boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator over all addresses in this set.
    Specified by:
      `getAddresses` in interface `AddressSetView`
    Overrides:
      `getAddresses` in class `AddressSet`
    Parameters:
      `forward` - if true the address are return in increasing order, otherwise in decreasing order.
    Returns:
      an iterator over all addresses in this set.

  - ### getAddresses

    public AddressIterator getAddresses(Address start, boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator over the addresses in this address set starting at the start address
    Specified by:
      `getAddresses` in interface `AddressSetView`
    Overrides:
      `getAddresses` in class `AddressSet`
    Parameters:
      `start` - address to start iterating at in the address set
      `forward` - if true address are return from lowest to highest, else from highest to lowest
    Returns:
      an iterator over the addresses in this address set starting at the start address

  - ### intersects

    public boolean intersects(AddressSetView addrSet)
    Description copied from interface: `AddressSetView`
    Determine if this address set intersects with the specified address set.
    Specified by:
      `intersects` in interface `AddressSetView`
    Overrides:
      `intersects` in class `AddressSet`
    Parameters:
      `addrSet` - address set to check intersection with.
    Returns:
      true if this set intersects the specified addrSet else false

  - ### intersects

    public boolean intersects(Address start, Address end)
    Description copied from interface: `AddressSetView`
    Determine if the start and end range intersects with the specified address set.
    Specified by:
      `intersects` in interface `AddressSetView`
    Overrides:
      `intersects` in class `AddressSet`
    Parameters:
      `start` - start of range
      `end` - end of range
    Returns:
      true if the given range intersects this address set.

  - ### xor

    public AddressSet xor(AddressSetView addrSet)
    Description copied from interface: `AddressSetView`
    Computes the exclusive-or of this address set with the given set. This method does not modify this address set.
    Specified by:
      `xor` in interface `AddressSetView`
    Overrides:
      `xor` in class `AddressSet`
    Parameters:
      `addrSet` - address set to exclusive-or with.
    Returns:
      AddressSet a new address set containing all addresses that are in either this set or the given set, but not in both sets

  - ### getFirstRange

    public AddressRange getFirstRange()
    Description copied from interface: `AddressSetView`
    Returns the first range in this set or null if the set is empty;
    Specified by:
      `getFirstRange` in interface `AddressSetView`
    Overrides:
      `getFirstRange` in class `AddressSet`
    Returns:
      the first range in this set or null if the set is empty;

  - ### getLastRange

    public AddressRange getLastRange()
    Description copied from interface: `AddressSetView`
    Returns the last range in this set or null if the set is empty;
    Specified by:
      `getLastRange` in interface `AddressSetView`
    Overrides:
      `getLastRange` in class `AddressSet`
    Returns:
      the last range in this set or null if the set is empty;

  - ### getRangeContaining

    public AddressRange getRangeContaining(Address address)
    Description copied from interface: `AddressSetView`
    Returns the range that contains the given address
    Specified by:
      `getRangeContaining` in interface `AddressSetView`
    Overrides:
      `getRangeContaining` in class `AddressSet`
    Parameters:
      `address` - the address for which to find a range.
    Returns:
      the range that contains the given address.

  - ### getProgram

    public Program getProgram()
    Description copied from interface: `Memory`
    Returns the program that this memory belongs to.
    Specified by:
      `getProgram` in interface `Memory`

  - ### getLoadedAndInitializedAddressSet

    public AddressSetView getLoadedAndInitializedAddressSet()
    Description copied from interface: `Memory`
    Returns the set of addresses which correspond to all the "loaded" memory blocks that have initialized data. This does not include initialized memory blocks that contain data from the program's file header such as debug sections.
    Specified by:
      `getLoadedAndInitializedAddressSet` in interface `Memory`

  - ### getAllInitializedAddressSet

    public AddressSetView getAllInitializedAddressSet()
    Description copied from interface: `Memory`
    Returns the set of addresses which correspond to all memory blocks that have initialized data. This includes initialized memory blocks that contain data from the program's file header that are not actually in the running in memory image, such as debug sections. Use `Memory.getLoadedAndInitializedAddressSet()` if you only want the addressed of the loaded in memory blocks.
    Specified by:
      `getAllInitializedAddressSet` in interface `Memory`

  - ### getInitializedAddressSet

    public AddressSetView getInitializedAddressSet()
    Description copied from interface: `Memory`
    Use `Memory.getLoadedAndInitializedAddressSet()` instead.
    Specified by:
      `getInitializedAddressSet` in interface `Memory`

  - ### getExecuteSet

    public AddressSetView getExecuteSet()
    Description copied from interface: `Memory`
    Returns the set of addresses which correspond to the executable memory.
    Specified by:
      `getExecuteSet` in interface `Memory`

  - ### isBigEndian

    public boolean isBigEndian()
    Description copied from interface: `Memory`
    Returns true if the memory is bigEndian, false otherwise.
    Specified by:
      `isBigEndian` in interface `Memory`

  - ### setLiveMemoryHandler

    public void setLiveMemoryHandler(LiveMemoryHandler handler)
    Description copied from interface: `Memory`
    Sets the live memory handler
    Specified by:
      `setLiveMemoryHandler` in interface `Memory`
    Parameters:
      `handler` - the live memory handler

  - ### getLiveMemoryHandler

    public LiveMemoryHandler getLiveMemoryHandler()
    Description copied from interface: `Memory`
    Returns the live memory handler instance used by this memory.
    Specified by:
      `getLiveMemoryHandler` in interface `Memory`
    Returns:
      the live memory handler

  - ### createInitializedBlock

    public MemoryBlock createInitializedBlock(String name, Address start, InputStream is, long length, TaskMonitor monitor, boolean overlay)
    Description copied from interface: `Memory`
    Create an initialized memory block based upon a data `InputStream` and add it to this Memory.

    Overlay Blocks: An overlay memory block may be created in two ways:

    - Specifying a `start` address within an existing overlay address space (`overlay` parameter is ignored), or
    - Specifying a `start` address within a physical memory address space and passing `overlay=true`. This use case will force the creation of a new unique overlay address space.
    Specified by:
      `createInitializedBlock` in interface `Memory`
    Parameters:
      `name` - block name (See `Memory.isValidMemoryBlockName(String)` for naming rules)
      `start` - start address of the block
      `is` - source of the data used to fill the block or null for zero initialization.
      `length` - the size of the block
      `monitor` - task monitor
      `overlay` - if true, the block will be created as an OVERLAY block. If the `start` address is a non-overlay memory address a new overlay address space will be created and the block will have a starting address at the same offset within the new overlay space. If the specified `start` address is an overlay address an overlay block will be created at that overlay address.
    Returns:
      new Initialized Memory Block

  - ### createInitializedBlock

    public MemoryBlock createInitializedBlock(String name, Address start, long size, byte initialValue, TaskMonitor monitor, boolean overlay)
    Description copied from interface: `Memory`
    Create an initialized memory block initialized and add it to this Memory. All bytes will be initialized to the specified value (NOTE: use of zero as the initial value is encouraged for reduced storage).

    Overlay Blocks: An overlay memory block may be created in two ways:

    - Specifying a `start` address within an existing overlay address space (`overlay` parameter is ignored), or
    - Specifying a `start` address within a physical memory address space and passing `overlay=true`. This use case will force the creation of a new unique overlay address space.
    Specified by:
      `createInitializedBlock` in interface `Memory`
    Parameters:
      `name` - block name (See `Memory.isValidMemoryBlockName(String)` for naming rules)
      `start` - start of the block
      `size` - block length (positive non-zero value required)
      `initialValue` - initialization value for every byte in the block.
      `monitor` - progress monitor, may be null.
      `overlay` - if true, the block will be created as an OVERLAY block. If the `start` address is a non-overlay memory address a new overlay address space will be created and the block will have a starting address at the same offset within the new overlay space. If the specified `start` address is an overlay address an overlay block will be created at that overlay address.
    Returns:
      new Initialized Memory Block

  - ### createUninitializedBlock

    public MemoryBlock createUninitializedBlock(String name, Address start, long size, boolean overlay)
    Description copied from interface: `Memory`
    Create an uninitialized memory block and add it to this Memory.

    Overlay Blocks: An overlay memory block may be created in two ways:

    - Specifying a `start` address within an existing overlay address space (`overlay` parameter is ignored), or
    - Specifying a `start` address within a physical memory address space and passing `overlay=true`. This use case will force the creation of a new unique overlay address space.
    Specified by:
      `createUninitializedBlock` in interface `Memory`
    Parameters:
      `name` - block name (See `Memory.isValidMemoryBlockName(String)` for naming rules)
      `start` - start of the block
      `size` - block length
      `overlay` - if true, the block will be created as an OVERLAY block. If the `start` address is a non-overlay memory address a new overlay address space will be created and the block will have a starting address at the same offset within the new overlay space. If the specified `start` address is an overlay address an overlay block will be created at that overlay address.
    Returns:
      new Uninitialized Memory Block

  - ### createBitMappedBlock

    public MemoryBlock createBitMappedBlock(String name, Address start, Address mappedAddress, long length, boolean overlay) throws LockException, MemoryConflictException, AddressOverflowException
    Description copied from interface: `Memory`
    Create a bit-mapped overlay memory block and add it to this Memory. Each byte address within the resulting memory block will correspond to a single bit location within the mapped region specified by `mappedAddress`.

    Overlay Blocks: An overlay memory block may be created in two ways:

    - Specifying a `start` address within an existing overlay address space (`overlay` parameter is ignored), or
    - Specifying a `start` address within a physical memory address space and passing `overlay=true`. This use case will force the creation of a new unique overlay address space.
    Specified by:
      `createBitMappedBlock` in interface `Memory`
    Parameters:
      `name` - block name (See `Memory.isValidMemoryBlockName(String)` for naming rules)
      `start` - start of the block
      `mappedAddress` - start address in the source block for the beginning of this block
      `length` - block length
      `overlay` - if true, the block will be created as an OVERLAY block. If the `start` address is a non-overlay memory address a new overlay address space will be created and the block will have a starting address at the same offset within the new overlay space. If the specified `start` address is an overlay address an overlay block will be created at that overlay address.
    Returns:
      new Bit Memory Block
    Throws:
      `LockException` - if exclusive lock not in place (see haveLock())
      `MemoryConflictException` - if the new block overlaps with a previous block
      `AddressOverflowException` - if block specification exceeds bounds of address space

  - ### createByteMappedBlock

    public MemoryBlock createByteMappedBlock(String name, Address start, Address mappedAddress, long length, ByteMappingScheme byteMappingScheme, boolean overlay) throws LockException, MemoryConflictException, AddressOverflowException, IllegalArgumentException
    Description copied from interface: `Memory`
    Create a byte-mapped memory block and add it to this memory. Each byte address within the resulting memory block will correspond to a byte within the mapped region specified by `mappedAddress`. While a 1:1 byte-mapping is the default, a specific byte-mapping ratio may be specified.

    Overlay Blocks: An overlay memory block may be created in two ways:

    - Specifying a `start` address within an existing overlay address space (`overlay` parameter is ignored), or
    - Specifying a `start` address within a physical memory address space and passing `overlay=true`. This use case will force the creation of a new unique overlay address space.
    Specified by:
      `createByteMappedBlock` in interface `Memory`
    Parameters:
      `name` - block name (See `Memory.isValidMemoryBlockName(String)` for naming rules)
      `start` - start of the block
      `mappedAddress` - start address in the source block for the beginning of this block
      `length` - block length
      `byteMappingScheme` - byte mapping scheme (may be null for 1:1 mapping)
      `overlay` - if true, the block will be created as an OVERLAY block. If the `start` address is a non-overlay memory address a new overlay address space will be created and the block will have a starting address at the same offset within the new overlay space. If the specified `start` address is an overlay address an overlay block will be created at that overlay address.
    Returns:
      new Bit Memory Block
    Throws:
      `LockException` - if exclusive lock not in place (see haveLock())
      `MemoryConflictException` - if the new block overlaps with a previous block
      `AddressOverflowException` - if block specification exceeds bounds of address space
      `IllegalArgumentException` - if invalid block name

  - ### createBlock

    public MemoryBlock createBlock(MemoryBlock block, String name, Address start, long length) throws LockException, MemoryConflictException, AddressOverflowException
    Description copied from interface: `Memory`
    Creates a MemoryBlock at the given address with the same properties as block, and adds it to this Memory. Initialized Default blocks will have block filled with 0's. Method will only create physical space blocks and will not create an overlay block.
    Specified by:
      `createBlock` in interface `Memory`
    Parameters:
      `block` - source block
      `name` - block name (See `Memory.isValidMemoryBlockName(String)` for naming rules).
      `start` - start of the block
      `length` - the size of the new block.
    Returns:
      new block
    Throws:
      `LockException` - if exclusive lock not in place (see haveLock())
      `MemoryConflictException` - if block specification conflicts with an existing block
      `AddressOverflowException` - if block specification exceeds bounds of address space

  - ### removeBlock

    public void removeBlock(MemoryBlock block, TaskMonitor monitor) throws LockException
    Description copied from interface: `Memory`
    Remove the memory block.
    Specified by:
      `removeBlock` in interface `Memory`
    Parameters:
      `block` - the block to be removed.
      `monitor` - monitor that is used to cancel the remove operation
    Throws:
      `LockException` - if exclusive lock not in place (see haveLock())

  - ### getSize

    public long getSize()
    Description copied from interface: `Memory`
    Get the memory size in bytes.
    Specified by:
      `getSize` in interface `Memory`

  - ### getBlock

    public MemoryBlock getBlock(Address addr)
    Description copied from interface: `Memory`
    Returns the Block which contains addr.
    Specified by:
      `getBlock` in interface `Memory`
    Parameters:
      `addr` - a valid data Address.
    Returns:
      the block containing addr; null if addr is not a valid location.

  - ### getBlock

    public MemoryBlock getBlock(String blockName)
    Description copied from interface: `Memory`
    Returns the Block with the specified blockName
    Specified by:
      `getBlock` in interface `Memory`
    Parameters:
      `blockName` - the name of the requested block
    Returns:
      the Block with the specified blockName

  - ### getBlocks

    public MemoryBlock[] getBlocks()
    Description copied from interface: `Memory`
    Returns an array containing all the memory blocks.
    Specified by:
      `getBlocks` in interface `Memory`

  - ### moveBlock

    public void moveBlock(MemoryBlock block, Address newStartAddr, TaskMonitor monitor) throws LockException, MemoryBlockException, MemoryConflictException, AddressOverflowException, NotFoundException
    Description copied from interface: `Memory`
    Move the memory block containing source address to the destination address.
    Specified by:
      `moveBlock` in interface `Memory`
    Parameters:
      `block` - block to be moved
      `newStartAddr` - new start address for block
      `monitor` - task monitor so the move block can be canceled
    Throws:
      `LockException` - if exclusive lock not in place (see haveLock())
      `MemoryBlockException` - if block movement is not permitted
      `MemoryConflictException` - if move would cause blocks to overlap.
      `AddressOverflowException` - if block movement would violate bounds of address space
      `NotFoundException` - if memoryBlock does not exist in this memory.

  - ### split

    public void split(MemoryBlock block, Address addr) throws MemoryBlockException, LockException, NotFoundException
    Description copied from interface: `Memory`
    Split a block at the given addr and create a new block starting at addr.
    Specified by:
      `split` in interface `Memory`
    Parameters:
      `block` - block to be split into two
      `addr` - address (within block) that will be the start of new block
    Throws:
      `MemoryBlockException` - memory split not permitted
      `LockException` - if exclusive lock not in place (see haveLock())
      `NotFoundException` - thrown if block does not exist in memory

  - ### join

    public MemoryBlock join(MemoryBlock blockOne, MemoryBlock blockTwo) throws LockException, MemoryBlockException, NotFoundException
    Description copied from interface: `Memory`
    Join the two blocks to create a single memory block. IMPORTANT! When done, both blockOne and blockTwo should no longer be used.
    Specified by:
      `join` in interface `Memory`
    Parameters:
      `blockOne` - block to be combined with blockTwo
      `blockTwo` - block to be combined with blockOne
    Returns:
      new block
    Throws:
      `LockException` - if exclusive lock not in place (see haveLock())
      `MemoryBlockException` - thrown if the blocks are not contiguous in the address space,
      `NotFoundException`

  - ### convertToInitialized

    public MemoryBlock convertToInitialized(MemoryBlock uninitializedBlock, byte initialValue) throws LockException, MemoryBlockException, NotFoundException
    Description copied from interface: `Memory`
    Convert an existing uninitialized block with an initialized block.
    Specified by:
      `convertToInitialized` in interface `Memory`
    Parameters:
      `uninitializedBlock` - uninitialized block to convert
      `initialValue` - initial value for the bytes
    Throws:
      `LockException` - if exclusive lock not in place (see haveLock())
      `MemoryBlockException` - if there is no block in memory at the same address as block or if the block lengths are not the same.
      `NotFoundException`

  - ### convertToUninitialized

    public MemoryBlock convertToUninitialized(MemoryBlock initializedBlock) throws MemoryBlockException, NotFoundException, LockException
    Specified by:
      `convertToUninitialized` in interface `Memory`
    Throws:
      `MemoryBlockException`
      `NotFoundException`
      `LockException`

  - ### findBytes

    public Address findBytes(Address addr, byte[] bytes, byte[] masks, boolean forward, TaskMonitor monitor)
    Description copied from interface: `Memory`
    Finds a sequence of contiguous bytes that match the given byte array at all bit positions where the mask contains an "on" bit. Search is performed over loaded memory only.
    Specified by:
      `findBytes` in interface `Memory`
    Parameters:
      `addr` - The beginning address in memory to search.
      `bytes` - the array of bytes to search for.
      `masks` - the array of masks. (One for each byte in the byte array) if all bits of each byte is to be checked (ie: all mask bytes are 0xff), then pass a null for masks.
      `forward` - if true, search in the forward direction.
    Returns:
      The address of where the first match is found. Null is returned if there is no match.

  - ### findBytes

    public Address findBytes(Address startAddr, Address endAddr, byte[] bytes, byte[] masks, boolean forward, TaskMonitor monitor)
    Description copied from interface: `Memory`
    Finds a sequence of contiguous bytes that match the given byte array at all bit positions where the mask contains an "on" bit. Starts at startAddr and ends at endAddr. If forward is true, search starts at startAddr and will end if startAddr ">" endAddr. If forward is false, search starts at start addr and will end if startAddr "<" endAddr.
    Specified by:
      `findBytes` in interface `Memory`
    Parameters:
      `startAddr` - The beginning address in memory to search.
      `endAddr` - The ending address in memory to search (inclusive).
      `bytes` - the array of bytes to search for.
      `masks` - the array of masks. (One for each byte in the byte array) if all bits of each byte is to be checked (ie: all mask bytes are 0xff), then pass a null for masks.
      `forward` - if true, search in the forward direction.
    Returns:
      The address of where the first match is found. Null is returned if there is no match.

  - ### getByte

    public byte getByte(Address addr) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get byte at addr.
    Specified by:
      `getByte` in interface `Memory`
    Parameters:
      `addr` - the Address of the byte.
    Returns:
      the byte.
    Throws:
      `MemoryAccessException` - if the address is not contained in any memory block.

  - ### getBytes

    public int getBytes(Address addr, byte[] dest) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get dest.length number of bytes starting at the given address.
    Specified by:
      `getBytes` in interface `Memory`
    Parameters:
      `addr` - the starting Address.
      `dest` - the byte array to populate.
    Returns:
      the number of bytes put into dest. May be less than dest.length if the requested number extends beyond available memory.
    Throws:
      `MemoryAccessException` - if the starting address is not contained in any memory block.

  - ### getBytes

    public int getBytes(Address addr, byte[] dest, int dIndex, int size) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get size number of bytes starting at the given address and populates dest starting at dIndex.
    Specified by:
      `getBytes` in interface `Memory`
    Parameters:
      `addr` - the starting Address.
      `dest` - the byte array to populate.
      `dIndex` - the offset into dest to place the bytes.
      `size` - the number of bytes to get.
    Returns:
      the number of bytes put into dest. May be less than size if the requested number extends beyond initialized / available memory.
    Throws:
      `MemoryAccessException` - if the starting address is not contained in any memory block or is an uninitialized location.

  - ### getShort

    public short getShort(Address addr) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get the short at addr.
    Specified by:
      `getShort` in interface `Memory`
    Parameters:
      `addr` - the Address where the short starts.
    Returns:
      the short.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getShort

    public short getShort(Address addr, boolean bigEndian) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get the short at addr using the specified endian order.
    Specified by:
      `getShort` in interface `Memory`
    Parameters:
      `addr` - the Address where the short starts.
      `bigEndian` - true means to get the short in bigEndian order
    Returns:
      the short.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getShorts

    public int getShorts(Address addr, short[] dest) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get dest.length number of shorts starting at the given address.
    Specified by:
      `getShorts` in interface `Memory`
    Parameters:
      `addr` - the starting Address.
      `dest` - the short array to populate.
    Returns:
      the number of shorts put into dest. May be less than dest.length if the requested number extends beyond available memory. If the number of retrievable bytes is odd, the final byte will be discarded.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getShorts

    public int getShorts(Address addr, short[] dest, int dIndex, int nElem) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get dest.length number of shorts starting at the given address.
    Specified by:
      `getShorts` in interface `Memory`
    Parameters:
      `addr` - the starting Address.
      `dest` - the short array to populate.
      `dIndex` - the offset into dest to place the shorts.
      `nElem` - the number of shorts to get.
    Returns:
      the number of shorts put into dest. May be less than dest.length if the requested number extends beyond available memory. If the number of retrievable bytes is odd, the final byte will be discarded.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getShorts

    public int getShorts(Address addr, short[] dest, int dIndex, int nElem, boolean isBigEndian) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get dest.length number of shorts starting at the given address.
    Specified by:
      `getShorts` in interface `Memory`
    Parameters:
      `addr` - the starting Address.
      `dest` - the short array to populate.
      `dIndex` - the offset into dest to place the shorts.
      `nElem` - the number of shorts to get.
      `isBigEndian` - true means to get the shorts in bigEndian order
    Returns:
      the number of shorts put into dest. May be less than dest.length if the requested number extends beyond available memory. If the number of retrievable bytes is odd, the final byte will be discarded.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getInt

    public int getInt(Address addr) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get the int at addr.
    Specified by:
      `getInt` in interface `Memory`
    Parameters:
      `addr` - the Address where the int starts.
    Returns:
      the int.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getInt

    public int getInt(Address addr, boolean bigEndian) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get the int at addr using the specified endian order.
    Specified by:
      `getInt` in interface `Memory`
    Parameters:
      `addr` - the Address where the int starts.
      `bigEndian` - true means to get the int in big endian order
    Returns:
      the int.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getInts

    public int getInts(Address addr, int[] dest) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get dest.length number of ints starting at the given address.
    Specified by:
      `getInts` in interface `Memory`
    Parameters:
      `addr` - the starting Address.
      `dest` - the int array to populate.
    Returns:
      the number of ints put into dest. May be less than dest.length if the requested number extends beyond available memory. If the number of retrievable bytes is not 0 mod 4, the final byte(s) will be discarded.
    Throws:
      `MemoryAccessException` - if the starting address is not contained in any memory block.

  - ### getInts

    public int getInts(Address addr, int[] dest, int dIndex, int nElem) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get dest.length number of ints starting at the given address.
    Specified by:
      `getInts` in interface `Memory`
    Parameters:
      `addr` - the starting Address.
      `dest` - the int array to populate.
      `dIndex` - the offset into dest to place the ints.
      `nElem` - the number of ints to get.
    Returns:
      the number of ints put into dest. May be less than dest.length if the requested number extends beyond available memory. If the number of retrievable bytes is not 0 mod 4, the final byte(s) will be discarded.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getInts

    public int getInts(Address addr, int[] dest, int dIndex, int nElem, boolean isBigEndian) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get dest.length number of ints starting at the given address.
    Specified by:
      `getInts` in interface `Memory`
    Parameters:
      `addr` - the starting Address.
      `dest` - the int array to populate.
      `dIndex` - the offset into dest to place the ints.
      `nElem` - the number of ints to get.
      `isBigEndian` - true means to get the ints in bigEndian order
    Returns:
      the number of ints put into dest. May be less than dest.length if the requested number extends beyond available memory. If the number of retrievable bytes is not 0 mod 4, the final byte(s) will be discarded.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getLong

    public long getLong(Address addr) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get the long at addr.
    Specified by:
      `getLong` in interface `Memory`
    Parameters:
      `addr` - the Address where the long starts.
    Returns:
      the long.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getLong

    public long getLong(Address addr, boolean bigEndian) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get the long at addr in the specified endian order.
    Specified by:
      `getLong` in interface `Memory`
    Parameters:
      `addr` - the Address where the long starts.
      `bigEndian` - true means to get the long in big endian order
    Returns:
      the long.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getLongs

    public int getLongs(Address addr, long[] dest) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get dest.length number of longs starting at the given address.
    Specified by:
      `getLongs` in interface `Memory`
    Parameters:
      `addr` - the starting Address.
      `dest` - the long array to populate.
    Returns:
      the number of longs put into dest. May be less than dest.length if the requested number extends beyond available memory. If the number of retrievable bytes is not 0 mod 8, the final byte(s) will be discarded.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getLongs

    public int getLongs(Address addr, long[] dest, int dIndex, int nElem) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get dest.length number of longs starting at the given address.
    Specified by:
      `getLongs` in interface `Memory`
    Parameters:
      `addr` - the starting Address.
      `dest` - the long array to populate.
      `dIndex` - the offset into dest to place the longs.
      `nElem` - the number of longs to get.
    Returns:
      the number of longs put into dest. May be less than dest.length if the requested number extends beyond available memory. If the number of retrievable bytes is not 0 mod 8, the final byte(s) will be discarded.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### getLongs

    public int getLongs(Address addr, long[] dest, int dIndex, int nElem, boolean isBigEndian) throws MemoryAccessException
    Description copied from interface: `Memory`
    Get dest.length number of longs starting at the given address.
    Specified by:
      `getLongs` in interface `Memory`
    Parameters:
      `addr` - the starting Address.
      `dest` - the long array to populate.
      `dIndex` - the offset into dest to place the longs.
      `nElem` - the number of longs to get.
      `isBigEndian` - true means to get the longs in bigEndian order
    Returns:
      the number of longs put into dest. May be less than dest.length if the requested number extends beyond available memory. If the number of retrievable bytes is not 0 mod 8, the final byte(s) will be discarded.
    Throws:
      `MemoryAccessException` - if not all needed bytes are contained in initialized memory.

  - ### setByte

    public void setByte(Address addr, byte value) throws MemoryAccessException
    Description copied from interface: `Memory`
    Write byte at addr.
    Specified by:
      `setByte` in interface `Memory`
    Parameters:
      `addr` - the Address of the byte.
      `value` - the data to write.
    Throws:
      `MemoryAccessException` - if writing is not allowed.

  - ### setBytes

    public void setBytes(Address addr, byte[] source) throws MemoryAccessException
    Description copied from interface: `Memory`
    Write size bytes from values at addr.
    Specified by:
      `setBytes` in interface `Memory`
    Parameters:
      `addr` - the starting Address.
      `source` - the bytes to write.
    Throws:
      `MemoryAccessException` - if writing is not allowed.

  - ### setBytes

    public void setBytes(Address addr, byte[] source, int sIndex, int size) throws MemoryAccessException
    Description copied from interface: `Memory`
    Write an array of bytes. This should copy size bytes or fail!
    Specified by:
      `setBytes` in interface `Memory`
    Parameters:
      `addr` - the starting Address of the bytes.
      `source` - an array to get bytes from.
      `sIndex` - the starting source index.
      `size` - the number of bytes to fill.
    Throws:
      `MemoryAccessException` - if writing is not allowed.

  - ### setShort

    public void setShort(Address addr, short value) throws MemoryAccessException
    Description copied from interface: `Memory`
    Write short at addr in big endian order.
    Specified by:
      `setShort` in interface `Memory`
    Parameters:
      `addr` - the Address of the short.
      `value` - the data to write.
    Throws:
      `MemoryAccessException` - if writing is not allowed.

  - ### setShort

    public void setShort(Address addr, short value, boolean bigEndian) throws MemoryAccessException
    Description copied from interface: `Memory`
    Write short at addr in the specified endian order.
    Specified by:
      `setShort` in interface `Memory`
    Parameters:
      `addr` - the Address of the short.
      `value` - the data to write.
      `bigEndian` - true means to write short in big endian order
    Throws:
      `MemoryAccessException` - if writing is not allowed.

  - ### setInt

    public void setInt(Address addr, int value) throws MemoryAccessException
    Description copied from interface: `Memory`
    Write int at addr.
    Specified by:
      `setInt` in interface `Memory`
    Parameters:
      `addr` - the Address of the int.
      `value` - the data to write.
    Throws:
      `MemoryAccessException` - if writing is not allowed.

  - ### setInt

    public void setInt(Address addr, int value, boolean bigEndian) throws MemoryAccessException
    Description copied from interface: `Memory`
    Write int at addr in the specified endian order.
    Specified by:
      `setInt` in interface `Memory`
    Parameters:
      `addr` - the Address of the int.
      `value` - the data to write.
      `bigEndian` - true means to write the short in bigEndian order
    Throws:
      `MemoryAccessException` - if writing is not allowed.

  - ### setLong

    public void setLong(Address addr, long value) throws MemoryAccessException
    Description copied from interface: `Memory`
    Write long at addr.
    Specified by:
      `setLong` in interface `Memory`
    Parameters:
      `addr` - the Address of the long.
      `value` - the data to write.
    Throws:
      `MemoryAccessException` - if writing is not allowed.

  - ### setLong

    public void setLong(Address addr, long value, boolean bigEndian) throws MemoryAccessException
    Description copied from interface: `Memory`
    Write long at addr in the specified endian order.
    Specified by:
      `setLong` in interface `Memory`
    Parameters:
      `addr` - the Address of the long.
      `value` - the data to write.
      `bigEndian` - true means to write the long in bigEndian order
    Throws:
      `MemoryAccessException` - if writing is not allowed.

  - ### findFirstAddressInCommon

    public Address findFirstAddressInCommon(AddressSetView set)
    Description copied from interface: `AddressSetView`
    Finds the first address in this collection that is also in the given addressSet.
    Specified by:
      `findFirstAddressInCommon` in interface `AddressSetView`
    Overrides:
      `findFirstAddressInCommon` in class `AddressSet`
    Parameters:
      `set` - the addressSet to search for the first (lowest) common address.
    Returns:
      the first address that is contained in this set and the given set.

  - ### createFileBytes

    public FileBytes createFileBytes(String filename, long offset, long size, InputStream is, TaskMonitor monitor) throws IOException
    Description copied from interface: `Memory`
    Stores a sequence of bytes into the program. Typically, this method is used by importers to store the original raw program bytes.
    Specified by:
      `createFileBytes` in interface `Memory`
    Parameters:
      `filename` - the name of the file from where the bytes originated
      `offset` - the offset into the file for the first byte in the input stream.
      `size` - the number of bytes to store from the input stream.
      `is` - the input stream that will supply the bytes to store in the program. Caller is responsible for closing input stream upon return.
      `monitor` - task monitor
    Returns:
      a FileBytes that was created to access the bytes.
    Throws:
      `IOException` - if there was an IOException saving the bytes to the program database.

  - ### getAllFileBytes

    public List<FileBytes> getAllFileBytes()
    Description copied from interface: `Memory`
    Returns a list of all the stored original file bytes objects
    Specified by:
      `getAllFileBytes` in interface `Memory`
    Returns:
      a list of all the stored original file bytes objects

  - ### deleteFileBytes

    public boolean deleteFileBytes(FileBytes descriptor)
    Description copied from interface: `Memory`
    Deletes a stored sequence of file bytes. The file bytes can only be deleted if there are no memory block references to the file bytes.
    Specified by:
      `deleteFileBytes` in interface `Memory`
    Parameters:
      `descriptor` - the FileBytes for the file bytes to be deleted.
    Returns:
      true if the FileBytes was deleted. If any memory blocks are referenced by this FileBytes or it is invalid then it will not be deleted and false will be returned.

  - ### createInitializedBlock

    public MemoryBlock createInitializedBlock(String name, Address start, FileBytes fileBytes, long offset, long size, boolean overlay)
    Description copied from interface: `Memory`
    Create an initialized memory block using bytes from a `FileBytes` object.

    Overlay Blocks: An overlay memory block may be created in two ways:

    - Specifying a `start` address within an existing overlay address space (`overlay` parameter is ignored), or
    - Specifying a `start` address within a physical memory address space and passing `overlay=true`. This use case will force the creation of a new unique overlay address space.
    Specified by:
      `createInitializedBlock` in interface `Memory`
    Parameters:
      `name` - block name (See `Memory.isValidMemoryBlockName(String)` for naming rules)
      `start` - starting address of the block
      `fileBytes` - the `FileBytes` object to use as the underlying source of bytes.
      `offset` - the offset into the FileBytes for the first byte of this memory block.
      `size` - block length (positive non-zero value required)
      `overlay` - if true, the block will be created as an OVERLAY block. If the `start` address is a non-overlay memory address a new overlay address space will be created and the block will have a starting address at the same offset within the new overlay space. If the specified `start` address is an overlay address an overlay block will be created at that overlay address.
    Returns:
      new Initialized Memory Block

  - ### getAddressSourceInfo

    public AddressSourceInfo getAddressSourceInfo(Address address)
    Description copied from interface: `Memory`
    Returns information (`AddressSourceInfo`) about the byte source at the given address.
    Specified by:
      `getAddressSourceInfo` in interface `Memory`
    Parameters:
      `address` - the address to query. Returns null if the address is not in memory.
    Returns:
      information (`AddressSourceInfo`) about the byte source at the given address or null if the address is not in memory.